<template>

  <v-content>
    <v-container fluid fill-height>
      <v-layout align-center justify-center>
        <v-flex xs12 sm8 md4>
          <img src="" alt="" class="image-logo">
          <v-card class="elevation-12">
            <form>
              <v-card-text>
                <input type="text" v-model="username">
              </v-card-text>
              <v-card-text>
                <input type="text" v-model="password">
              </v-card-text>
              <v-card-actions class="action-card">
                <v-btn color="info" @click="submit">Login</v-btn>
              </v-card-actions>
              <v-divider></v-divider>
              <div class="extra-card">
                <p>You do not have an account?
                  <router-link :to="{name: 'Register.vue'}">Register</router-link>
                </p>
              </div>
            </form>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </v-content>
</template>

<script>
import {HOST_API} from "../../vars";

export default {
  data: () => ({
    username: '',
    password_show: false,
    password: '',
    dictionary: {
      custom: {
        username: {
          required: () => 'Field can not be empty',
          max: 'The username field may not be greater than 30 characters'
          // custom messages
        },
        password: {
          required: () => 'Password can not be empty',
        }
      }
    }
  }),

  mounted() {

  },

  methods: {
    submit() {
      this.onLogin()
    },
    onLogin() {
      fetch(HOST_API + '/api/token/', {
        method: 'POST',
        body: JSON.stringify({username: this.username, password: this.password}),
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => res.json())
          .catch(error => console.error('Error:', error))
          .then(response => {
            this.$store.state.authentication = response;
            this.$store.commit('login');
            this.$router.push({name: 'Project'});
          });
    },
  },
}
</script>

<style scoped>
/* TODO: Pending adjusted design */
.image-logo {
  width: 40%;
  margin-bottom: 20px;
}

.action-card {
  display: flex;
  justify-content: center;
}

.extra-card {
  padding: 20px 0;
}
</style>
